/////////////////////////////////////////////////////////////////////////////
//		ShArc.cpp
#include	<windows.h>
#include	<shlobj.h>
#include	<initguid.h>
#include	"util.h"
#include	"ShArc.h"
#include	"resource.h"


/////////////////////////////////////////////////////////
//	錾

//萔
DEFINE_GUID( CLSID_ShellExtension,
0xA6129F41, 0x6FF8, 0x11D3, 0x86, 0x2D, 0x00, 0xC0, 0x4F, 0xCF, 0x67, 0x92 );

//ϐ
HINSTANCE	g_hInst;					//DLL̃CX^X


/////////////////////////////////////////////////////////
//	֐

//C
extern "C"
BOOL WINAPI DllMain( HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved )
{
	if( dwReason == DLL_PROCESS_ATTACH )
		g_hInst = hInstance;

	return	TRUE;
}
//
extern "C"
BOOL WINAPI _DllMainCRTStartup( HINSTANCE hInst, DWORD dwReason, LPVOID lpReserved )
{
	return	DllMain( hInst, dwReason, lpReserved );
}
void main(void) {}
void* operator new(size_t size){return GlobalAlloc(GPTR,size);}
void operator delete(void* ptr){GlobalFree((HGLOBAL)ptr);}


/////////////////////////////////////////////////////////
//	NXIuWFNg̑

//NXIuWFNg̎擾
STDAPI DllGetClassObject( REFCLSID rclsid, REFIID riid, LPVOID* ppvObj )
{
	HRESULT			hr;
	CClassFactory*	pClassFactory;

	*ppvObj = NULL;
	if( rclsid != CLSID_ShellExtension )
		return	CLASS_E_CLASSNOTAVAILABLE;

	pClassFactory = new CClassFactory;
	if( pClassFactory == NULL )
		return	E_OUTOFMEMORY;

	hr = pClassFactory->QueryInterface( riid, ppvObj );
		 pClassFactory->Release();

	return	hr;
}

//NXIuWFNg̏I
STDAPI DllCanUnloadNow()
{
	return	IsDllUnlocked() ? S_OK : S_FALSE;
}


/////////////////////////////////////////////////////////
//	Cu̓o^E폜

//Cu̓o^
STDAPI DllRegisterServer(void)
{
	TCHAR	szBuff[MAX_PATH];
	CSetup	cSetup( CLSID_ShellExtension );
	INT		nRet;

	LoadString( g_hInst, IDS_REGIST, szBuff, MAX_PATH );
	nRet = MessageBox( GetForegroundWindow(), szBuff, _T("ShArc"), MB_YESNO|MB_ICONQUESTION );

	switch( nRet )
	{
	case	IDYES:
		GetModuleFileName( g_hInst, szBuff, MAX_PATH );
		cSetup.RegCLSID( _T("ShArc"), szBuff );
		cSetup.RegShellEx( _T("Folder"), _T("DragDropHandlers"   ), _T("ShArc") );
		cSetup.RegShellEx( _T("Drive" ), _T("DragDropHandlers"   ), _T("ShArc") );
		cSetup.RegShellEx( _T("Folder"), _T("ContextMenuHandlers"), _T("ShArc") );
		cSetup.RegShellEx( _T("Drive" ), _T("ContextMenuHandlers"), _T("ShArc") );
		cSetup.RegShellEx( _T("*"     ), _T("ContextMenuHandlers"), _T("ShArc") );
		break;

	case	IDNO:
		GetModuleFileName( g_hInst, szBuff, MAX_PATH );
		cSetup.RegCLSID( _T("ShArc"), szBuff );
		cSetup.RegShellEx  ( _T("Folder"), _T("DragDropHandlers"   ), _T("ShArc") );
		cSetup.RegShellEx  ( _T("Drive" ), _T("DragDropHandlers"   ), _T("ShArc") );
		cSetup.UnregShellEx( _T("Folder"), _T("ContextMenuHandlers"), _T("ShArc") );
		cSetup.UnregShellEx( _T("Drive" ), _T("ContextMenuHandlers"), _T("ShArc") );
		cSetup.UnregShellEx( _T("*"     ), _T("ContextMenuHandlers"), _T("ShArc") );
		break;
	}

	return	S_OK;
}

//Cu̍폜
STDAPI DllUnregisterServer(void)
{
	CSetup	cSetup( CLSID_ShellExtension );

	cSetup.UnregCLSID( );
	cSetup.UnregShellEx( _T("Folder"), _T("DragDropHandlers"   ), _T("ShArc") );
	cSetup.UnregShellEx( _T("Drive" ), _T("DragDropHandlers"   ), _T("ShArc") );
	cSetup.UnregShellEx( _T("Folder"), _T("ContextMenuHandlers"), _T("ShArc") );
	cSetup.UnregShellEx( _T("Drive" ), _T("ContextMenuHandlers"), _T("ShArc") );
	cSetup.UnregShellEx( _T("*"     ), _T("ContextMenuHandlers"), _T("ShArc") );

	return	S_OK;
}
