/////////////////////////////////////////////////////////////////////////////
//		ShArc.h


/////////////////////////////////////////////////////////
//	W[̓o^E폜

class CSetup
{
private:
	TCHAR		m_szCLSID[40];

public:
	CSetup( REFCLSID );
	~CSetup( void );

	BOOL		RegCLSID( LPTSTR, LPTSTR );
	BOOL		RegShellEx( LPTSTR, LPTSTR, LPTSTR );
	BOOL		UnregCLSID( void );
	BOOL		UnregShellEx( LPTSTR, LPTSTR, LPTSTR );
};


/////////////////////////////////////////////////////////
//	ꗗ̊Ǘ

class CList
{
private:
	LPCTSTR*	m_szItem;					//̔z
	ULONG		m_cItemMax;					//z̍ő吔
	ULONG		m_cItemCnt;					//žݐ

public:
	CList( ULONG );
	~CList();

	ULONG		GetCount( void );
	BOOL		AddItem( LPCTSTR );
	LPCTSTR		GetItem( ULONG );
};


/////////////////////////////////////////////////////////
//	Ƀt@C̊Ǘ

//`
typedef	INT	ID_DLL;
typedef	INT	ID_ARC;
enum	{
	ID_DLL_CAB,		ID_DLL_7ZIP,	ID_DLL_UNZIP,
	ID_DLL_UNLHA,	ID_DLL_UNRAR,	ID_DLL_TAR,
	ID_DLL_MAX
};
enum	{
	ID_ARC_CAB,	ID_ARC_7Z,	ID_ARC_ZIP,
	ID_ARC_LHA,	ID_ARC_RAR,	ID_ARC_TAR,
	ID_ARC_SFX=0x8000,		ID_ARC_NOT=-1
};

class CArchive
{
private:
	HMODULE		m_hDLL[ID_DLL_MAX];			//DLL̃nh

public:
	//DLL
	CArchive();
	~CArchive();
	INT			Command( ID_DLL, LPCTSTR );
	BOOL		CheckArchive( ID_DLL, LPCTSTR );

	//R}h
	ID_ARC		CheckFileType( LPCTSTR );
	BOOL		ExtractArchive( ID_ARC, LPCTSTR, LPCTSTR );
	BOOL		CompressArchive( ID_ARC, LPCTSTR, LPCTSTR, LPCTSTR );
	BOOL		CompressSFXArchive( ID_ARC, LPCTSTR, LPCTSTR, LPCTSTR );

	//WJ
	BOOL		CheckExtractFiles( CList* );
	BOOL		ExtractFiles( LPCTSTR, CList* );

	//k
	BOOL		CheckCompressFiles( VOID );
	BOOL		CompressFiles( ID_ARC, LPCTSTR, CList*  );
	ID_ARC		CompressDialogBox( LPTSTR );
};


/////////////////////////////////////////////////////////
//	IUnknown̐錾

//֐
BOOL IsDllUnlocked();

//NXIuWFNg̊Ǘ
class CClassFactory : public IClassFactory
{
private:
	ULONG		m_nRef;						//DLL̎QƉ

public:
	CClassFactory();
	~CClassFactory();

	//IUnknown
	STDMETHODIMP			QueryInterface( REFIID, LPVOID* );
	STDMETHODIMP_(ULONG)	AddRef();
	STDMETHODIMP_(ULONG)	Release();

	//IClassFactory
	STDMETHODIMP			CreateInstance( LPUNKNOWN, REFIID, LPVOID* );
	STDMETHODIMP			LockServer( BOOL );
};

//VFg
class CShellExtension : public IShellExtInit, IContextMenu
{
private:
	ULONG		m_nRef;						//DLL̎QƉ
	TCHAR		m_szPath[MAX_PATH];			//Ώۂ̃pX
	CList*		m_pList;					//Ώۃt@C̈ꗗ
	CArchive*	m_pArchive;					//Ƀt@C̑

public:
	CShellExtension();
	~CShellExtension();

	//IUnknown
	STDMETHODIMP			QueryInterface( REFIID, LPVOID* );
	STDMETHODIMP_(ULONG)	AddRef();
	STDMETHODIMP_(ULONG)	Release();

	//IShellExtInit
	STDMETHODIMP			Initialize( LPCITEMIDLIST, LPDATAOBJECT, HKEY );

	//IContextMenu
	STDMETHODIMP			QueryContextMenu( HMENU, UINT, UINT, UINT, UINT );
	STDMETHODIMP			InvokeCommand( LPCMINVOKECOMMANDINFO );
	STDMETHODIMP			GetCommandString( UINT, UINT, UINT*, LPSTR, UINT );
};


/////////////////////////////////////////////////////////
//	֐̐錾

//GNX|[g
STDAPI DllGetClassObject( REFCLSID, REFIID, LPVOID* );
STDAPI DllCanUnloadNow();
STDAPI DllRegisterServer( void );
STDAPI DllUnregisterServer( void );

//ϐ錾
extern	HINSTANCE	g_hInst;				//DLL̃CX^X
